<template>
  <div

        :class="[
          'relative min-h-100 border border-gray-600',
          elemento.classes.columns,
          rowCounts>0 ? elemento.classes.rows : '',
        ]"
      >
          <img class="object-cover object-center w-full h-full" :src="'/assets/projects/'+identificador.title+'/'+elemento.src" alt="">

        <div class="absolute top-0 z-40 flex items-start justify-between w-full gap-2 bg-gray-900 bg-opacity-50 pl-4">
            <div class="flex flex-col pt-2">
          <div class="flex items-center gap-3">
            <span class="text-xs">Tamaño en columnas</span
            ><select
              class="text-xs px-2 py-1 bg-gray-800 text-white"
              @change="handleColSpan()"
              v-model="elemento.colSpan"
            >
              <option value="auto">auto</option>
              <option
                v-for="span in columnCount"
                :value="span"
                :key="'span' + span"
              >
                {{ span }}
              </option>
            </select>
          </div>
          <div v-if="rowCount>0" class="flex items-center gap-3">
            <span class="text-xs">Tamaño en filas</span
            ><select
              class="text-xs px-2 py-1 bg-gray-800 text-white"
              @change="handleRowSpan()"
              v-model="elemento.rowSpan"
            >
              <option selected value="auto">auto</option>
              <option
                v-for="span in rowCount"
                :value="span"
                :key="'span-row' + span"
              >
                {{ span }}
              </option>
            </select>
          </div>
          <div class="flex flex-col gap-2 p-2">
            <div
              class="flex items-center gap-3"
              v-if="elemento.colSpan === 'auto'"
            >
              <span class="text-xs">posición de Columnas de Inicio</span>
              <select
                class="text-xs px-2 py-1 bg-gray-800 text-white"
                @change="handleColSpan()"
                v-model="elemento.posicionXIni"
              >
                <option selected value="auto">auto</option>
                <option
                  v-for="posxini in columnCount + 1"
                  :key="'ini-' + posxini"
                  :value="posxini"
                >
                  {{ posxini }}
                </option>
              </select>
            </div>
              <div
                class="flex items-center gap-3"
                v-if="elemento.colSpan === 'auto'"
              >
                <span class="text-xs">posición de Columnas de Final</span>
                <select
                  class="text-xs px-2 py-1 bg-gray-800 text-white"
                  @change="handleColSpan()"
                  v-model="elemento.posicionXFin"
                >
                  <option selected value="auto">auto</option>
                  <option
                    v-for="posxfin in columnCount + 1"
                    :key="'fin-' + posxfin"
                    :value="posxfin"
                  >
                    {{ posxfin }}
                  </option>
                </select>
            </div>

            <div class="flex items-center gap-3" v-if="elemento.rowSpan === 'auto' && rowCount>0">
              <span class="text-xs">posición de Filas de Inicio</span>
              <select
              class="text-xs px-2 py-1 bg-gray-800 text-white"
                @change="handleRowSpan()"
                v-model="elemento.posicionYIni"
              >
                <option selected value="auto">auto</option>
                <option
                  v-for="posyini in rowCount + 1"
                  :key="'ini-' + posyini"
                  :value="posyini"
                >
                  {{ posyini }}
                </option>
              </select>
              </div>
              <div class="flex items-center gap-3" v-if="elemento.rowSpan === 'auto' && rowCount>0">
              <span class="text-xs">posición de Filas de Final</span>
              <select
              class="text-xs px-2 py-1 bg-gray-800 text-white"
                @change="handleRowSpan()"
                v-model="elemento.posicionYFin"
              >
                <option selected value="auto">auto</option>
                <option
                  v-for="posyfin in rowCount + 1"
                  :key="'fin-' + posyfin"
                  :value="posyfin"
                >
                  {{ posyfin }}
                </option>
              </select>
            </div>
          </div>
            </div>
            <button @click="handleDelete()" type="button" class="w-max p-2 bg-transparent">
              <i class='bx bx-x text-white text-2xl'></i>
            </button>
        </div>
      </div>
</template>

<script>
export default {
    props: {
        idproject:{
            type: Number,
            required: true
        },
        elemento: {
            type: Object,
            required: true
        },
        identificador: {
            type: Object,
            required: true
        },
        columnCount: {
            type: Number,
            required: true
        },
        rowCount: {
            type: Number,
            required: true
        },
        index:{
          type:Number,
        },
    },
    data() {
        return {
            element:this.elemento,
            columnCounts:this.columnCount,
            rowCounts:this.rowCount
        }
    },
    watch: {
      rowCount: function (newVal, oldVal) {
        if(newVal!=oldVal){
          this.rowCounts=this.rowCount;
        }
      },
      columnCount: function (newVal, oldVal) {
        if(newVal!=oldVal){
          this.columnCounts=this.columnCount;
        }
      },
    },
    methods: {
      handleDelete(){
        let formData = new FormData();

      formData.append('type','deleteimage' );
      formData.append('carpeta',this.identificador.title );
      formData.append('name',this.element.src );
      let token=  document.head.querySelector('meta[name="csrf-token"]') ? document.head.querySelector('meta[name="csrf-token"]').content : '';
    formData.append('_token',token );
    fetch('/admin/projectgallery/add',{
        method:'POST',
        body:formData,
    })
    .then((response)=>{return response.json();})
    .then((data)=>{
        console.log(data);
        this.$emit('deleteItem',this.index);
    });
    //     this.axios.post(`/api/project/${this.idproject}/projectgallery/upgrade/`, formData, {
    //   })
    //   .then(response => {

    //     this.$emit('deleteItem',this.index);
    //   });
      },
    handleColSpan() {
    if(this.element.colSpan === "auto"){
      this.element.classes.columns = `col-start-${this.element.posicionXIni} col-end-${this.element.posicionXFin}`;
    }else{
        this.element.classes.columns = `col-span-${this.element.colSpan}`;
    }
     this.$emit('updateclass',this.counter);
    },
    handleRowSpan() {

      if (this.element.rowSpan === "auto") {
        this.element.classes.rows = `row-start-${this.element.posicionYIni} row-end-${this.element.posicionYFin}`;
      } else {
        this.element.classes.rows = `row-span-${this.element.rowSpan}`;
      }
       this.$emit('updateclass',this.counter);
    },
    }
}
</script>

<style>

</style>
